diff --git a/contrib/ntp/libntp/ntp_intres.c b/contrib/ntp/libntp/ntp_intres.c
index 9fc3815ef007..29546147db8a 100644
--- a/contrib/ntp/libntp/ntp_intres.c
+++ b/contrib/ntp/libntp/ntp_intres.c
@@ -84,12 +84,6 @@
 #  include <netdb.h>
 # endif
 # include <resolv.h>
-# ifdef HAVE_INT32_ONLY_WITH_DNS
-#  define HAVE_INT32
-# endif
-# ifdef HAVE_U_INT32_ONLY_WITH_DNS
-#  define HAVE_U_INT32
-# endif
 #endif
 
 #include "ntp.h"
diff --git a/contrib/ntp/libntp/ntp_realpath.c b/contrib/ntp/libntp/ntp_realpath.c
index 116542945153..90e5a0d59e75 100644
--- a/contrib/ntp/libntp/ntp_realpath.c
+++ b/contrib/ntp/libntp/ntp_realpath.c
@@ -103,7 +103,7 @@ realpath1(const char *path, char *resolved)
 	size_t left_len, resolved_len, next_token_len;
 	unsigned symlinks;
 	ssize_t slen;
-	char left[NTP_PATH_MAX], next_token[NTP_PATH_MAX], symlink[NTP_PATH_MAX];
+	char left[NTP_PATH_MAX], next_token[NTP_PATH_MAX], link_tgt[NTP_PATH_MAX];
 
 	symlinks = 0;
 	if (path[0] == '/') {
@@ -157,7 +157,7 @@ realpath1(const char *path, char *resolved)
 			resolved[resolved_len++] = '/';
 			resolved[resolved_len] = '\0';
 		}
-		if (next_token[0] == '\0') {
+		if ('\0' == next_token[0]) {
 			/* Handle consequential slashes. */
 			continue;
 		} else if (strcmp(next_token, ".") == 0) {
@@ -187,23 +187,24 @@ realpath1(const char *path, char *resolved)
 		if (lstat(resolved, &sb) != 0)
 			return (NULL);
 		if (S_ISLNK(sb.st_mode)) {
-			if (symlinks++ > NTP_MAXSYMLINKS) {
+			if (++symlinks > NTP_MAXSYMLINKS) {
 				errno = ELOOP;
 				return (NULL);
 			}
-			slen = readlink(resolved, symlink, sizeof(symlink));
-			if (slen <= 0 || slen >= (ssize_t)sizeof(symlink)) {
-				if (slen < 0)
-					; /* keep errno from readlink(2) call */
-				else if (slen == 0)
+			slen = readlink(resolved, link_tgt, sizeof(link_tgt));
+			if (slen <= 0 || slen >= (ssize_t)sizeof(link_tgt)) {
+				if (slen < 0) {
+					/* keep errno from readlink(2) call */
+				} else if (slen == 0) {
 					errno = ENOENT;
-				else
+				} else {
 					errno = ENAMETOOLONG;
+				}
 				return (NULL);
 			}
-			symlink[slen] = '\0';
-			if (symlink[0] == '/') {
-				resolved[1] = 0;
+			link_tgt[slen] = '\0';
+			if (link_tgt[0] == '/') {
+				resolved[1] = '\0';
 				resolved_len = 1;
 			} else {
 				/* Strip the last path component. */
@@ -214,26 +215,26 @@ realpath1(const char *path, char *resolved)
 
 			/*
 			 * If there are any path components left, then
-			 * append them to symlink. The result is placed
+			 * append them to link_tgt. The result is placed
 			 * in `left'.
 			 */
 			if (p != NULL) {
-				if (symlink[slen - 1] != '/') {
-					if (slen + 1 >= (ssize_t)sizeof(symlink)) {
+				if (link_tgt[slen - 1] != '/') {
+					if (slen + 1 >= (ssize_t)sizeof(link_tgt)) {
 						errno = ENAMETOOLONG;
 						return (NULL);
 					}
-					symlink[slen] = '/';
-					symlink[slen + 1] = 0;
+					link_tgt[slen] = '/';
+					link_tgt[slen + 1] = 0;
 				}
-				left_len = strlcat(symlink, left,
-				    sizeof(symlink));
-				if (left_len >= sizeof(symlink)) {
+				left_len = strlcat(link_tgt, left,
+						   sizeof(link_tgt));
+				if (left_len >= sizeof(link_tgt)) {
 					errno = ENAMETOOLONG;
 					return (NULL);
 				}
 			}
-			left_len = strlcpy(left, symlink, sizeof(left));
+			left_len = strlcpy(left, link_tgt, sizeof(left));
 		} else if (!S_ISDIR(sb.st_mode) && p != NULL) {
 			errno = ENOTDIR;
 			return (NULL);
diff --git a/contrib/ntp/libntp/numtoa.c b/contrib/ntp/libntp/numtoa.c
index 51645de01c30..ac8978ee5e58 100644
--- a/contrib/ntp/libntp/numtoa.c
+++ b/contrib/ntp/libntp/numtoa.c
@@ -12,7 +12,6 @@
 #include <ctype.h>
 
 #include "ntp_fp.h"
-#include "lib_strbuf.h"
 #include "ntp_stdlib.h"
 
 char *
@@ -34,7 +33,11 @@ numtoa(
 }
 
 
-/* Convert a refid & stratum to a string */
+/* 
+ * Convert a refid & stratum to a string.  If stratum is negative and the
+ * refid consists entirely of graphic chars, up to an optional
+ * terminating zero, display as text similar to stratum 0 & 1.
+ */
 const char *
 refid_str(
 	u_int32	refid,
@@ -43,33 +46,44 @@ refid_str(
 {
 	char *	text;
 	size_t	tlen;
-	char *  cp;
-
-	if (stratum > 1)
-		return numtoa(refid);
-
-	LIB_GETBUF(text);
-	text[0] = '.';
-	/* What if any non-NUL char is not printable? */
-	memcpy(&text[1], &refid, sizeof(refid));
-	text[1 + sizeof(refid)] = '\0';
-	tlen = strlen(text);
-	text[tlen] = '.';
-	text[tlen + 1] = '\0';
+	char *	cp;
+	int	printable;
 
 	/*
-	 * Now make sure the contents are 'graphic'.
-	 *
-	 * This refid is expected to be up to 4 ascii graphics.
-	 * If any character is not a graphic, replace it with a space.
-	 * This will at least alert the viewer of a problem.
+	 * ntpd can have stratum = 0 and refid 127.0.0.1 in orphan mode.
+	 * https://bugs.ntp.org/3854.  Mirror the refid logic in timer().
 	 */
-	for (cp = text + 1; *cp; ++cp) {
-		if (!isgraph((int)*cp)) {
-			*cp = ' ';
+	if (0 == stratum && LOOPBACKADR_N == refid) {
+		return ".ORPH.";
+	}
+	printable = FALSE;
+	if (stratum < 2) {
+		text = lib_getbuf();
+		text[0] = '.';
+		memcpy(&text[1], &refid, sizeof(refid));
+		text[1 + sizeof(refid)] = '\0';
+		tlen = strlen(text);
+		text[tlen] = '.';
+		text[tlen + 1] = '\0';
+		/*
+		 * Now make sure the contents are 'graphic'.
+		 *
+		 * This refid is expected to be up to 4 printable ASCII.
+		 * isgraph() is similar to isprint() but excludes space.
+		 * If any character is not graphic, replace it with a '?'.
+		 * This will at least alert the viewer of a problem.
+		 */
+		for (cp = text + 1; '\0' != *cp; ++cp) {
+			if (!isgraph((int)*cp)) {
+				printable = FALSE;
+				*cp = '?';
+			}
+		}
+		if (   (stratum < 0 && printable)
+		    || stratum < 2) {
+			return text;
 		}
 	}
-
-	return text;
+	return numtoa(refid);
 }
 
diff --git a/contrib/ntp/libntp/prettydate.c b/contrib/ntp/libntp/prettydate.c
index deacc26bbe2b..060f79e5e327 100644
--- a/contrib/ntp/libntp/prettydate.c
+++ b/contrib/ntp/libntp/prettydate.c
@@ -6,7 +6,6 @@
 
 #include "ntp_fp.h"
 #include "ntp_unixtime.h"	/* includes <sys/time.h> */
-#include "lib_strbuf.h"
 #include "ntp_stdlib.h"
 #include "ntp_assert.h"
 #include "ntp_calendar.h"
diff --git a/contrib/ntp/libntp/recvbuff.c b/contrib/ntp/libntp/recvbuff.c
index d84a87d68501..6e7cda5d373d 100644
--- a/contrib/ntp/libntp/recvbuff.c
+++ b/contrib/ntp/libntp/recvbuff.c
@@ -93,41 +93,54 @@ initialise_buffer(recvbuf_t *buff)
 
 static void
 create_buffers(
-	size_t		nbufs)
+	size_t			nbufs
+)
 {
+	static const u_int	chunk =
 #   ifndef DEBUG
-	static const u_int chunk = RECV_INC;
+					RECV_INC;
 #   else
 	/* Allocate each buffer individually so they can be free()d
 	 * during ntpd shutdown on DEBUG builds to keep them out of heap
 	 * leak reports.
 	 */
-	static const u_int chunk = 1;
+					1;
 #   endif
-
-	register recvbuf_t *bufp;
-	u_int i;
-	size_t abuf;
+	static int/*BOOL*/	doneonce;
+	recvbuf_t *		bufp;
+	u_int			i;
+	size_t			abuf;
 
 	/*[bug 3666]: followup -- reset shortfalls in all cases */
 	abuf = nbufs + buffer_shortfall;
 	buffer_shortfall = 0;
 
-	if (limit_recvbufs <= total_recvbufs)
+	if (limit_recvbufs <= total_recvbufs) {
+		if (!doneonce) {
+			msyslog(LOG_CRIT, "Unable to allocate receive"
+					  " buffer, %lu/%lu",
+				total_recvbufs, limit_recvbufs);
+			doneonce = TRUE;
+		}
 		return;
-	
-	if (abuf < nbufs || abuf > RECV_BATCH)
+	}
+
+	if (abuf < nbufs || abuf > RECV_BATCH) {
 		abuf = RECV_BATCH;	/* clamp on overflow */
-	else
+	} else {
 		abuf += (~abuf + 1) & (RECV_INC - 1);	/* round up */
-	
-	if (abuf > (limit_recvbufs - total_recvbufs))
+	}
+	if (abuf > (limit_recvbufs - total_recvbufs)) {
 		abuf = limit_recvbufs - total_recvbufs;
+	}
 	abuf += (~abuf + 1) & (chunk - 1);		/* round up */
 	
 	while (abuf) {
 		bufp = calloc(chunk, sizeof(*bufp));
 		if (!bufp) {
+			msyslog(LOG_CRIT, "Out of memory, allocating "
+					  "%u recvbufs, %lu bytes",
+				chunk, (u_long)sizeof(*bufp) * chunk);
 			limit_recvbufs = total_recvbufs;
 			break;
 		}
diff --git a/contrib/ntp/libntp/refnumtoa.c b/contrib/ntp/libntp/refnumtoa.c
index cfebefe1ed18..1e1aa4e06b4c 100644
--- a/contrib/ntp/libntp/refnumtoa.c
+++ b/contrib/ntp/libntp/refnumtoa.c
@@ -5,7 +5,6 @@
 #include <stdio.h>
 
 #include "ntp_net.h"
-#include "lib_strbuf.h"
 #include "ntp_stdlib.h"
 
 const char *
diff --git a/contrib/ntp/libntp/snprintf.c b/contrib/ntp/libntp/snprintf.c
index f4685e1ad4b6..52ec17a04eb2 100644
--- a/contrib/ntp/libntp/snprintf.c
+++ b/contrib/ntp/libntp/snprintf.c
@@ -1587,7 +1587,7 @@ rpl_asprintf(va_alist) va_dcl
 }
 #endif	/* HW_WANT_RPL_ASPRINTF */
 #else	/* Dummy declaration to avoid empty translation unit warnings. */
-int main(void);
+NONEMPTY_TRANSLATION_UNIT
 #endif	/* HW_WANT_RPL_SNPRINTF || HW_WANT_RPL_VSNPRINTF || HW_WANT_RPL_ASPRINTF || [...] */
 
 #if TEST_SNPRINTF
diff --git a/contrib/ntp/libntp/socket.c b/contrib/ntp/libntp/socket.c
index 11fb004690c4..08e6ffbebb6a 100644
--- a/contrib/ntp/libntp/socket.c
+++ b/contrib/ntp/libntp/socket.c
@@ -195,11 +195,11 @@ open_socket(
 	)
 void
 sendpkt(
-	sockaddr_u *		dest,
-	struct interface *	ep,
-	int			ttl,
-	struct pkt *		pkt,
-	int			len
+	sockaddr_u *	dest,
+	endpt *		ep,
+	int		ttl,
+	struct pkt *	pkt,
+	int		len
 	)
 
 static inline int
@@ -207,9 +207,9 @@ read_refclock_packet(SOCKET fd, struct refclockio *rp, l_fp ts)
 
 static inline int
 read_network_packet(
-	SOCKET			fd,
-	struct interface *	itf,
-	l_fp			ts
+	SOCKET	fd,
+	endpt *	itf,
+	l_fp	ts
 	)
 
 void
diff --git a/contrib/ntp/libntp/socktoa.c b/contrib/ntp/libntp/socktoa.c
index 4071b0a45be0..f83f78b87981 100644
--- a/contrib/ntp/libntp/socktoa.c
+++ b/contrib/ntp/libntp/socktoa.c
@@ -21,7 +21,6 @@
 #include <isc/sockaddr.h>
 
 #include "ntp_fp.h"
-#include "lib_strbuf.h"
 #include "ntp_stdlib.h"
 #include "ntp.h"
 
diff --git a/contrib/ntp/libntp/socktohost.c b/contrib/ntp/libntp/socktohost.c
index fdf9adb9e2e6..3ea5b56004d8 100644
--- a/contrib/ntp/libntp/socktohost.c
+++ b/contrib/ntp/libntp/socktohost.c
@@ -15,7 +15,6 @@
 #include <stdio.h>
 
 #include "ntp_fp.h"
-#include "lib_strbuf.h"
 #include "ntp_stdlib.h"
 #include "ntp.h"
 #include "ntp_debug.h"
diff --git a/contrib/ntp/libntp/ssl_init.c b/contrib/ntp/libntp/ssl_init.c
index 925893257b7f..6de8a0b5fccc 100644
--- a/contrib/ntp/libntp/ssl_init.c
+++ b/contrib/ntp/libntp/ssl_init.c
@@ -23,67 +23,60 @@
 #  define CMAC_LENGTH	16
 #  define CMAC		"AES128CMAC"
 # endif /*HAVE_OPENSSL_CMAC_H*/
-int ssl_init_done;
 
-#if OPENSSL_VERSION_NUMBER < 0x10100000L
+EVP_MD_CTX *digest_ctx;
+
 
 static void
 atexit_ssl_cleanup(void)
 {
-	if (!ssl_init_done) {
+	if (NULL == digest_ctx) {
 		return;
 	}
-
-	ssl_init_done = FALSE;
+	EVP_MD_CTX_free(digest_ctx);
+	digest_ctx = NULL;
+#if OPENSSL_VERSION_NUMBER < 0x10100000L
 	EVP_cleanup();
 	ERR_free_strings();
+#endif	/* OpenSSL < 1.1 */
 }
 
+
 void
 ssl_init(void)
 {
 	init_lib();
 
-	if ( ! ssl_init_done) {
-	    ERR_load_crypto_strings();
-	    OpenSSL_add_all_algorithms();
-	    atexit(&atexit_ssl_cleanup);
-	    ssl_init_done = TRUE;
+	if (NULL == digest_ctx) {
+#if OPENSSL_VERSION_NUMBER < 0x10100000L
+		ERR_load_crypto_strings();
+		OpenSSL_add_all_algorithms();
+#endif	/* OpenSSL < 1.1 */
+		digest_ctx = EVP_MD_CTX_new();
+		INSIST(digest_ctx != NULL);
+		atexit(&atexit_ssl_cleanup);
 	}
 }
 
-#else /* OPENSSL_VERSION_NUMBER >= 0x10100000L */
-
-void
-ssl_init(void)
-{
-	init_lib();
-	ssl_init_done = TRUE;
-}
-
-#endif /* OPENSSL_VERSION_NUMBER */
-
 
 void
 ssl_check_version(void)
 {
 	u_long	v;
+	char *  buf;
 
 	v = OpenSSL_version_num();
 	if ((v ^ OPENSSL_VERSION_NUMBER) & ~0xff0L) {
-		msyslog(LOG_WARNING,
-		    "OpenSSL version mismatch. Built against %lx, you have %lx",
-		    (u_long)OPENSSL_VERSION_NUMBER, v);
-		fprintf(stderr,
-		    "OpenSSL version mismatch. Built against %lx, you have %lx\n",
-		    (u_long)OPENSSL_VERSION_NUMBER, v);
+		LIB_GETBUF(buf);
+		snprintf(buf, LIB_BUFLENGTH, 
+			 "OpenSSL version mismatch."
+			 "Built against %lx, you have %lx\n",
+			 (u_long)OPENSSL_VERSION_NUMBER, v);
+		msyslog(LOG_WARNING, "%s", buf);
+		fputs(buf, stderr);
 	}
-
 	INIT_SSL();
 }
-
-#else	/* !OPENSSL */
-# define MD5_LENGTH	16
 #endif	/* OPENSSL */
 
 
@@ -102,7 +95,7 @@ keytype_from_text(
 	int		key_type;
 	u_int		digest_len;
 #ifdef OPENSSL	/* --*-- OpenSSL code --*-- */
-	const u_long	max_digest_len = MAX_MAC_LEN - sizeof(keyid_t);
+	const u_long	max_digest_len = MAX_MDG_LEN;
 	char *		upcased;
 	char *		pch;
 	EVP_MD const *	md;
@@ -204,7 +197,7 @@ keytype_from_text(
  */
 const char *
 keytype_name(
-	int nid
+	int type
 	)
 {
 	static const char unknown_type[] = "(unknown key type)";
@@ -212,23 +205,18 @@ keytype_name(
 
 #ifdef OPENSSL
 	INIT_SSL();
-	name = OBJ_nid2sn(nid);
+	name = OBJ_nid2sn(type);
 
 #   ifdef ENABLE_CMAC
-	if (NID_cmac == nid) {
+	if (NID_cmac == type) {
 		name = CMAC;
-
-		if (debug) {
-			fprintf(stderr, "%s:%d:%s():%s:nid\n",
-				__FILE__, __LINE__, __func__, CMAC);
-		}
 	} else
 #   endif /*ENABLE_CMAC*/
 	if (NULL == name) {
 		name = unknown_type;
 	}
 #else	/* !OPENSSL follows */
-	if (NID_md5 == nid)
+	if (NID_md5 == type)
 		name = "MD5";
 	else
 		name = unknown_type;
@@ -251,13 +239,13 @@ keytype_name(
  */
 char *
 getpass_keytype(
-	int	keytype
+	int	type
 	)
 {
 	char	pass_prompt[64 + 11 + 1]; /* 11 for " Password: " */
 
 	snprintf(pass_prompt, sizeof(pass_prompt),
-		 "%.64s Password: ", keytype_name(keytype));
+		 "%.64s Password: ", keytype_name(type));
 
 	return getpass(pass_prompt);
 }
diff --git a/contrib/ntp/libntp/statestr.c b/contrib/ntp/libntp/statestr.c
index e712dc87e32d..bde1f50e7e74 100644
--- a/contrib/ntp/libntp/statestr.c
+++ b/contrib/ntp/libntp/statestr.c
@@ -8,7 +8,6 @@
 #include "ntp_stdlib.h"
 #include "ntp_fp.h"
 #include "ntp.h"
-#include "lib_strbuf.h"
 #include "ntp_refclock.h"
 #include "ntp_control.h"
 #include "ntp_string.h"
diff --git a/contrib/ntp/libntp/systime.c b/contrib/ntp/libntp/systime.c
index 76fba7fe1608..8d10b2e43f82 100644
--- a/contrib/ntp/libntp/systime.c
+++ b/contrib/ntp/libntp/systime.c
@@ -16,7 +16,6 @@
 #include "timevalops.h"
 #include "timespecops.h"
 #include "ntp_calendar.h"
-#include "lib_strbuf.h"
 
 #ifdef HAVE_SYS_PARAM_H
 # include <sys/param.h>
diff --git a/contrib/ntp/libntp/timexsup.c b/contrib/ntp/libntp/timexsup.c
index 979a7c4aea8e..21f7738d3e5f 100644
--- a/contrib/ntp/libntp/timexsup.c
+++ b/contrib/ntp/libntp/timexsup.c
@@ -6,14 +6,27 @@
  */
 
 #include "config.h"
-#include "timexsup.h"
 #include <limits.h>
 #include <math.h>
 
+#ifdef HAVE_SYS_TIME_H
+# include <sys/time.h>
+#else
+# ifdef HAVE_TIME_H
+#  include <time.h>
+# endif
+#endif
 #ifdef HAVE_SYS_TIMEX_H
 # include <sys/timex.h>
+#else
+# ifdef HAVE_TIMEX_H
+#  include <timex.h>
+# endif
 #endif
 
+#include "ntp_types.h"
+#include "timexsup.h"
+
 #if defined(MOD_NANO) != defined(STA_NANO)
 # warning inconsistent definitions of MOD_NANO vs STA_NANO
 #endif
@@ -41,10 +54,11 @@ dbl_from_var_long(
 	)
 {
 #ifdef STA_NANO
-	if (status & STA_NANO)
+	if (STA_NANO & status) {
 		return (double)lval * 1e-9;
+	}
 #else
-	(void)status;
+	UNUSED_ARG(status);
 #endif
 	return (double)lval * 1e-6;
 }
@@ -67,7 +81,7 @@ var_long_from_dbl(
 	*modes |= MOD_NANO;
 	dval *= 1e+9;
 #else
-	(void)modes;
+	UNUSED_ARG(modes);
 	dval *= 1e+6;
 #endif
 	return clamp_rounded(dval);
diff --git a/contrib/ntp/libntp/uglydate.c b/contrib/ntp/libntp/uglydate.c
index 66b5139096b4..165578674185 100644
--- a/contrib/ntp/libntp/uglydate.c
+++ b/contrib/ntp/libntp/uglydate.c
@@ -7,7 +7,6 @@
 
 #include "ntp_fp.h"
 #include "ntp_unixtime.h"
-#include "lib_strbuf.h"
 #include "ntp_stdlib.h"
 
 
diff --git a/contrib/ntp/libntp/vint64ops.c b/contrib/ntp/libntp/vint64ops.c
index 1d5087d95438..23c9f26dcfac 100644
--- a/contrib/ntp/libntp/vint64ops.c
+++ b/contrib/ntp/libntp/vint64ops.c
@@ -15,24 +15,25 @@
 
 #include "ntp_types.h"
 #include "ntp_fp.h"
+#include "ntp_malloc.h"
 #include "vint64ops.h"
 
 /* -------------------------------------------------------------------------*/
 
 vint64
 strtouv64(
-	char const *		begp,
-	char const ** const	endp,
-	int			base
+	char *	begp,
+	char ** endp,
+	int	base
 	)
 {
-	vint64  res;
-	u_char  digit;
-	int     sig, num;
-	const u_char *src;
+	vint64	res;
+	u_char	digit;
+	int	sig, num;
+	u_char *src;
 	
 	num = sig = 0;
-	src = (const u_char*)begp;
+	src = (u_char *)begp;
 	while (isspace(*src))
 		src++;
 
@@ -61,7 +62,7 @@ strtouv64(
 		return res;
 	}
 	
-	memset(&res, 0, sizeof(res));
+	ZERO(res);
 	while (*src) {
 		if (isdigit(*src))
 			digit = *src - '0';
@@ -97,7 +98,7 @@ strtouv64(
 	if (!num)
 		errno = EINVAL;
 	if (endp)
-		*endp = (const char *)src;
+		*endp = (char *)src;
 	if (sig)
 		M_NEG(res.D_s.hi, res.D_s.lo);
 	return res;
diff --git a/contrib/ntp/libntp/work_thread.c b/contrib/ntp/libntp/work_thread.c
index c1fe5c20c995..0d15c6e36e6f 100644
--- a/contrib/ntp/libntp/work_thread.c
+++ b/contrib/ntp/libntp/work_thread.c
@@ -376,8 +376,12 @@ send_blocking_resp_internal(
 	{
 #	    ifdef WORK_PIPE
 		if (1 != write(c->resp_write_pipe, "", 1))
-			msyslog(LOG_WARNING, "async resolver: %s",
-				"failed to notify main thread!");
+			msyslog(LOG_WARNING, "async resolver: blocking_get%sinfo"
+				" failed to notify main thread!",
+				(BLOCKING_GETNAMEINFO == resp->rtype)
+				    ? "name"
+				    : "addr"
+				);
 #	    else
 		tickle_sem(c->responses_pending);
 #	    endif
@@ -489,7 +493,7 @@ start_blocking_thread(
 
 /* --------------------------------------------------------------------
  * Create a worker thread. There are several differences between POSIX
- * and Windows, of course -- most notably the Windows thread is no
+ * and Windows, of course -- most notably the Windows thread is a
  * detached thread, and we keep the handle around until we want to get
  * rid of the thread. The notification scheme also differs: Windows
  * makes use of semaphores in both directions, POSIX uses a pipe for
@@ -520,9 +524,12 @@ start_blocking_thread_internal(
 	}
 	/* remember the thread priority is only within the process class */
 	if (!SetThreadPriority(c->thr_table[0].thnd,
-			       THREAD_PRIORITY_BELOW_NORMAL))
+			       THREAD_PRIORITY_BELOW_NORMAL)) {
 		msyslog(LOG_ERR, "Error lowering blocking thread priority: %m");
-
+	}
+	if (NULL != pSetThreadDescription) {
+		(*pSetThreadDescription)(c->thr_table[0].thnd, L"ntp_worker");
+	}
 	resumed = ResumeThread(c->thr_table[0].thnd);
 	DEBUG_INSIST(resumed);
 	c->thread_ref = &c->thr_table[0];
diff --git a/contrib/ntp/libparse/Makefile.am b/contrib/ntp/libparse/Makefile.am
index a4a3ed264f2f..f88e3b2af36d 100644
--- a/contrib/ntp/libparse/Makefile.am
+++ b/contrib/ntp/libparse/Makefile.am
@@ -94,14 +94,9 @@ AM_LDFLAGS = $(NTP_HARD_LDFLAGS)
 EXTRA_DIST = parsesolaris.c parsestreams.c mkinfo_scmd.sed mkinfo_rcmd.sed info_trimble.c
 
 info_trimble.c: $(top_srcdir)/include/trimble.h $(srcdir)/Makefile.am $(srcdir)/mkinfo_scmd.sed $(srcdir)/mkinfo_rcmd.sed
-	sed -n -f $(srcdir)/mkinfo_scmd.sed $(top_srcdir)/include/trimble.h  > info_trimble.new
-	sed -n -f $(srcdir)/mkinfo_rcmd.sed $(top_srcdir)/include/trimble.h >> info_trimble.new
-	mv -f info_trimble.new $@
-
-#$(srcdir)/info_trimble.c: $(top_srcdir)/include/trimble.h $(srcdir)/Makefile.am $(srcdir)/mkinfo_scmd.sed $(srcdir)/mkinfo_rcmd.sed
-#	sed -n -f $(srcdir)/mkinfo_scmd.sed $(top_srcdir)/include/trimble.h  > info_trimble.new
-#	sed -n -f $(srcdir)/mkinfo_rcmd.sed $(top_srcdir)/include/trimble.h >> info_trimble.new
-#	mv -f info_trimble.new $@
+	$(AM_V_at)$(SED) -n -f $(srcdir)/mkinfo_scmd.sed $(top_srcdir)/include/trimble.h  > info_trimble.new
+	$(AM_V_at)$(SED) -n -f $(srcdir)/mkinfo_rcmd.sed $(top_srcdir)/include/trimble.h >> info_trimble.new
+	$(AM_V_at)mv -f info_trimble.new $@
 
 kieee754io.o: $(srcdir)/ieee754io.c
 	 $(COMPILE) $(K_CFLAGS) -c $(srcdir)/ieee754io.c -o $@
@@ -165,11 +160,11 @@ parse: $(parsesolaris_OBJECTS) libparse_kernel.a ../libntp/libntp.a
 
 parsesolaris.o: sys/systm.h
 
-# [Bug3608] Solaris has inconsistent definitions of ffs() and fls(). Drop the
+# [Bug 3608] Solaris has inconsistent definitions of ffs() and fls(). Drop the
 # ones from 'systm.h'.
 sys/systm.h:
 	-mkdir sys
-	sed -e '/f[fl]s(.*)/d' < /usr/include/sys/systm.h > sys/systm.h
+	$(SED) -e '/f[fl]s(.*)/d' < /usr/include/sys/systm.h > sys/systm.h
 
 ## check-libparse is invoked by ntpd/Makefile.am
 check-libparse: $(noinst_LIBRARIES)
diff --git a/contrib/ntp/libparse/clk_computime.c b/contrib/ntp/libparse/clk_computime.c
index 7273ac762e37..10ec9a7c1c97 100644
--- a/contrib/ntp/libparse/clk_computime.c
+++ b/contrib/ntp/libparse/clk_computime.c
@@ -182,7 +182,7 @@ inp_computime(
 }
 
 #else /* not (REFCLOCK && CLOCK_PARSE && CLOCK_COMPUTIME) */
-int clk_computime_bs;
+NONEMPTY_TRANSLATION_UNIT
 #endif /* not (REFCLOCK && CLOCK_PARSE && CLOCK_COMPUTIME) */
 
 /*
diff --git a/contrib/ntp/libparse/clk_dcf7000.c b/contrib/ntp/libparse/clk_dcf7000.c
index 0621cd5649e4..4aeb4c39ba9f 100644
--- a/contrib/ntp/libparse/clk_dcf7000.c
+++ b/contrib/ntp/libparse/clk_dcf7000.c
@@ -176,7 +176,7 @@ inp_dcf7000(
 }
 
 #else /* not (REFCLOCK && CLOCK_PARSE && CLOCK_DCF7000) */
-int clk_dcf7000_bs;
+NONEMPTY_TRANSLATION_UNIT
 #endif /* not (REFCLOCK && CLOCK_PARSE && CLOCK_DCF7000) */
 
 /*
diff --git a/contrib/ntp/libparse/clk_hopf6021.c b/contrib/ntp/libparse/clk_hopf6021.c
index a747581b75dc..436c92cb3b88 100644
--- a/contrib/ntp/libparse/clk_hopf6021.c
+++ b/contrib/ntp/libparse/clk_hopf6021.c
@@ -20,7 +20,7 @@
 # include <config.h>
 #endif
 
-#include <ntp_types.h>
+#include "ntp_types.h"
 
 #if defined(REFCLOCK) && defined(CLOCK_PARSE) && defined(CLOCK_HOPF6021)
 
diff --git a/contrib/ntp/libparse/clk_meinberg.c b/contrib/ntp/libparse/clk_meinberg.c
index e4ebf0acc605..1aa839bfd15a 100644
--- a/contrib/ntp/libparse/clk_meinberg.c
+++ b/contrib/ntp/libparse/clk_meinberg.c
@@ -733,7 +733,7 @@ gps_input(
 }
 
 #else /* not (REFCLOCK && CLOCK_PARSE && CLOCK_MEINBERG) */
-int clk_meinberg_bs;
+NONEMPTY_TRANSLATION_UNIT
 #endif /* not (REFCLOCK && CLOCK_PARSE && CLOCK_MEINBERG) */
 
 /*
diff --git a/contrib/ntp/libparse/clk_rawdcf.c b/contrib/ntp/libparse/clk_rawdcf.c
index 3fa74997c9bf..9b6eeafb163f 100644
--- a/contrib/ntp/libparse/clk_rawdcf.c
+++ b/contrib/ntp/libparse/clk_rawdcf.c
@@ -742,7 +742,7 @@ inp_rawdcf(
 }
 
 #else /* not (REFCLOCK && CLOCK_PARSE && CLOCK_RAWDCF) */
-int clk_rawdcf_bs;
+NONEMPTY_TRANSLATION_UNIT
 #endif /* not (REFCLOCK && CLOCK_PARSE && CLOCK_RAWDCF) */
 
 /*
diff --git a/contrib/ntp/libparse/clk_rcc8000.c b/contrib/ntp/libparse/clk_rcc8000.c
index 11d52acc5a24..e9bb115da4f5 100644
--- a/contrib/ntp/libparse/clk_rcc8000.c
+++ b/contrib/ntp/libparse/clk_rcc8000.c
@@ -163,7 +163,7 @@ inp_rcc8000(
 }
 
 #else  /* not (REFCLOCK && CLOCK_PARSE && CLOCK_RCC8000) */
-int clk_rcc8000_bs;
+NONEMPTY_TRANSLATION_UNIT
 #endif  /* not (REFCLOCK && CLOCK_PARSE && CLOCK_RCC8000) */
 
 /*
diff --git a/contrib/ntp/libparse/clk_schmid.c b/contrib/ntp/libparse/clk_schmid.c
index d85b1a5da512..5dd52047aa0f 100644
--- a/contrib/ntp/libparse/clk_schmid.c
+++ b/contrib/ntp/libparse/clk_schmid.c
@@ -222,7 +222,7 @@ inp_schmid(
 }
 
 #else /* not (REFCLOCK && CLOCK_PARSE && CLOCK_SCHMID) */
-int clk_schmid_bs;
+NONEMPTY_TRANSLATION_UNIT
 #endif /* not (REFCLOCK && CLOCK_PARSE && CLOCK_SCHMID) */
 
 /*
diff --git a/contrib/ntp/libparse/clk_sel240x.c b/contrib/ntp/libparse/clk_sel240x.c
index b1390b4cefb1..f27b662491f1 100644
--- a/contrib/ntp/libparse/clk_sel240x.c
+++ b/contrib/ntp/libparse/clk_sel240x.c
@@ -168,5 +168,5 @@ cvt_sel240x( unsigned char *buffer,
 }
 
 #else  /* not (REFCLOCK && CLOCK_PARSE && CLOCK_SEL240X) */
-int clk_sel240x_bs;
+NONEMPTY_TRANSLATION_UNIT
 #endif /* not (REFCLOCK && CLOCK_PARSE && CLOCK_SEL240X) */
diff --git a/contrib/ntp/libparse/clk_trimtaip.c b/contrib/ntp/libparse/clk_trimtaip.c
index a60d01ec1870..ce930952ffa2 100644
--- a/contrib/ntp/libparse/clk_trimtaip.c
+++ b/contrib/ntp/libparse/clk_trimtaip.c
@@ -181,7 +181,7 @@ inp_trimtaip(
 }
 
 #else /* not (REFCLOCK && CLOCK_PARSE && CLOCK_TRIMTAIP) */
-int clk_trimtaip_bs;
+NONEMPTY_TRANSLATION_UNIT
 #endif /* not (REFCLOCK && CLOCK_PARSE && CLOCK_TRIMTAIP) */
 
 /*
diff --git a/contrib/ntp/libparse/clk_trimtsip.c b/contrib/ntp/libparse/clk_trimtsip.c
index 8cf5660657cc..5af69d349eea 100644
--- a/contrib/ntp/libparse/clk_trimtsip.c
+++ b/contrib/ntp/libparse/clk_trimtsip.c
@@ -388,7 +388,7 @@ cvt_trimtsip(
 }
 
 #else /* not (REFCLOCK && CLOCK_PARSE && CLOCK_TRIMTSIP && !PARSESTREAM) */
-int clk_trimtsip_bs;
+NONEMPTY_TRANSLATION_UNIT
 #endif /* not (REFCLOCK && CLOCK_PARSE && CLOCK_TRIMTSIP && !PARSESTREAM) */
 
 /*
diff --git a/contrib/ntp/libparse/clk_varitext.c b/contrib/ntp/libparse/clk_varitext.c
index 0d830354d799..a4c6d31b797a 100644
--- a/contrib/ntp/libparse/clk_varitext.c
+++ b/contrib/ntp/libparse/clk_varitext.c
@@ -252,7 +252,7 @@ inp_varitext(
 }
 
 #else /* not (REFCLOCK && CLOCK_PARSE && CLOCK_VARITEXT) */
-int clk_varitext_bs;
+NONEMPTY_TRANSLATION_UNIT
 #endif /* not (REFCLOCK && CLOCK_PARSE && CLOCK_VARITEXT) */
 
 /*
diff --git a/contrib/ntp/libparse/clk_wharton.c b/contrib/ntp/libparse/clk_wharton.c
index e1ef61d55bdb..2df425bc67b7 100644
--- a/contrib/ntp/libparse/clk_wharton.c
+++ b/contrib/ntp/libparse/clk_wharton.c
@@ -9,7 +9,7 @@
 #include <config.h>
 #endif
 
-#include <ntp_types.h>
+#include "ntp_types.h"
 
 #if defined(REFCLOCK) && defined(CLOCK_PARSE) && defined(CLOCK_WHARTON_400A)
 /*
diff --git a/contrib/ntp/libparse/ieee754io.c b/contrib/ntp/libparse/ieee754io.c
index 61bc8533b0d7..b41a96c2170e 100644
--- a/contrib/ntp/libparse/ieee754io.c
+++ b/contrib/ntp/libparse/ieee754io.c
@@ -50,8 +50,6 @@ static void put_byte (unsigned char *, offsets_t, int *, unsigned char);
 
 #ifdef LIBDEBUG
 
-#include "lib_strbuf.h"
-
 static char *
 fmt_blong(
 	  unsigned long val,
@@ -396,7 +394,22 @@ fetch_ieee754(
 	}
     }
 }
-  
+
+/*
+ * DLH: This function is currently unused in ntpd.  If you think about
+ * using it, be sure it does what you intend.  I notice the bufpp arg
+ * is never referenced, and the calculated mantissa_high & mantissa_low
+ * are only referenced in debug output.  It seems they're supposed to
+ * be composed into an ieee754-format float and stored at *bufpp or
+ * possibly **bufpp.  Brought to my attention by this:
+ *
+ * ieee754io.c:414:10: warning: variable 'mantissa_low' set but not used
+ * [-Wunused-but-set-variable]
+ *
+ * To quiet it I'm #ifdef'ing the function away for now, here and below
+ * the call to it in main().
+ */
+#ifdef PUT_IEEE754_UNUSED_FUNC
 int
 put_ieee754(
 	    unsigned char **bufpp,
@@ -536,6 +549,7 @@ put_ieee754(
     }
   return IEEE_OK;
 }
+#endif	/* PUT_IEEE754_UNUSED_FUNC */
 
 
 #if defined(DEBUG) && defined(LIBDEBUG)
@@ -562,8 +576,11 @@ int main(
   printf("fetch from %f = %d\n", f, fetch_ieee754((void *)&f_p, IEEE_DOUBLE, &fp, native_off));
   printf("fp [%s %s] = %s\n", fmt_blong(fp.l_ui, 32), fmt_blong(fp.l_uf, 32), mfptoa(fp.l_ui, fp.l_uf, 15));
   f_p = &f;
+#ifdef PUT_IEEE754_UNUSED_FUNC
   put_ieee754((void *)&f_p, IEEE_DOUBLE, &fp, native_off);
-  
+/* there should be a check on *f_p (f) having the expected result here */
+#endif	/* PUT_IEEE754_UNUSED_FUNC */
+
   return 0;
 }
 
diff --git a/contrib/ntp/libparse/parse.c b/contrib/ntp/libparse/parse.c
index 69395ac4a560..56f2c3702bd8 100644
--- a/contrib/ntp/libparse/parse.c
+++ b/contrib/ntp/libparse/parse.c
@@ -875,7 +875,7 @@ parse_setcs(
 }
 
 #else /* not (REFCLOCK && CLOCK_PARSE) */
-int parse_bs;
+NONEMPTY_TRANSLATION_UNIT
 #endif /* not (REFCLOCK && CLOCK_PARSE) */
 
 /*
diff --git a/contrib/ntp/libparse/parse_conf.c b/contrib/ntp/libparse/parse_conf.c
index 37871c9de887..ad7a47aa937f 100644
--- a/contrib/ntp/libparse/parse_conf.c
+++ b/contrib/ntp/libparse/parse_conf.c
@@ -148,7 +148,7 @@ clockformat_t *clockformats[] =
 unsigned short nformats = sizeof(clockformats) / sizeof(clockformats[0]) - 1;
 
 #else /* not (REFCLOCK && CLOCK_PARSE) */
-int parse_conf_bs;
+NONEMPTY_TRANSLATION_UNIT
 #endif /* not (REFCLOCK && CLOCK_PARSE) */
 
 /*
diff --git a/contrib/ntp/ntpd/cmd_args.c b/contrib/ntp/ntpd/cmd_args.c
index aa461cb4dbe6..a604feb00b54 100644
--- a/contrib/ntp/ntpd/cmd_args.c
+++ b/contrib/ntp/ntpd/cmd_args.c
@@ -178,16 +178,14 @@ getCmdOpts(
 
 	if (HAVE_OPT( UPDATEINTERVAL )) {
 		long val = OPT_VALUE_UPDATEINTERVAL;
-
-		if (val >= 0)
-			interface_interval = val;
-		else {
-			fprintf(stderr,
-				"command line interface update interval %ld must not be negative\n",
-				val);
-			msyslog(LOG_ERR,
-				"command line interface update interval %ld must not be negative",
-				val);
+		const char errfmt[] =
+			"-U/--updateinterval %ld must be >= 0\n";
+
+		if (val >= 0) {
+			endpt_scan_period = val;
+		} else {
+			fprintf(stderr, errfmt, val);
+			msyslog(LOG_ERR, errfmt, val);
 			errflg++;
 		}
 	}
diff --git a/contrib/ntp/ntpd/complete.conf.in b/contrib/ntp/ntpd/complete.conf.in
index 77b619773fbf..adda4e4fa921 100644
--- a/contrib/ntp/ntpd/complete.conf.in
+++ b/contrib/ntp/ntpd/complete.conf.in
@@ -33,40 +33,45 @@ tinker allan 1500 dispersion 15 freq 0 huffpuff 7200 panic 1000 step 0.128 stepo
 broadcastclient
 server 127.127.1.0 mode 4294967295 prefer true
 fudge 127.127.1.0 time1 0 time2 1.1 stratum 7 refid Abcd minjitter 0.2
-pool 0.north-america.pool.ntp.org. iburst preempt
-server 1.north-america.pool.ntp.org. iburst
-server -4 2.north-america.pool.ntp.org. minpoll 6 maxpoll 10 iburst
-server -6 ntp.davehart.net. minpoll 6 maxpoll 10 version 5 burst iburst
-peer -6 davehart.broker.freenet6.net. ident "autokey-group" xleave autokey
-peer -4 192.168.192.168 key 1 noselect
+pool 2.ubuntu.pool.ntp.org. iburst preempt
+pool 2.freebsd.pool.ntp.org. iburst
+server -6 2.debian.pool.ntp.org. minpoll 6 maxpoll 10 iburst
+server -4 ntp.davehart.net. minpoll 6 maxpoll 10 version 5 burst iburst
+peer -6 ntp.md. ident "autokey-group" xleave autokey
+peer -4 198.51.100.123 key 1 noselect
 server [fe80::123%1] xmtnonce
-broadcast 192.168.192.255
-manycastclient 224.0.1.1
-manycastclient ff05::101
+broadcast 192.0.2.255
+manycastclient 224.0.1.1 key 14 iburst
+manycastclient ff05::101 maxpoll 6 key 1
 manycastserver 224.0.1.1 ff05::101
 multicastclient 224.0.1.1 ff05::101
 mru maxage 64 mindepth 600 initalloc 600 initmem 16 incalloc 99 incmem 4 maxdepth 1024 maxmem 4096
 discard minimum 1 average 3 monitor 3000
 pollskewlist 3 1|2 4 3|4 default 6|7
-restrict default ippeerlimit -1
-restrict default ippeerlimit 0 nomodify limited kod noserve nomrulist
+restrict default
+restrict default ippeerlimit 0 nomodify limited kod nopeer noserve nomrulist
 restrict source ippeerlimit 1
 restrict source ippeerlimit 2 nomodify limited kod
-restrict trusted.host.name.example.com. ippeerlimit -1 nomodify
-restrict [fe80::1] mask [ffff:ffff:ffff:ffff:ffff:ffff:ffff:ffff] ippeerlimit -1
-restrict 127.0.0.1 mask 255.255.255.255 ippeerlimit -1
-restrict 127.0.0.2 ippeerlimit -1 serverresponse fuzz
-restrict ::1 ippeerlimit -1
+restrict trusted.host.name.example.com. nomodify
+delrestrict trusted.host.name.example.com.
+restrict 192.0.2.66 epeer flake lowpriotrap mssntp noepeer noquery notrap notrust ntpport version
+delrestrict source 192.0.2.123
+delrestrict source [2001:db8::123]
+restrict fe80::1
+restrict 127.0.0.1
+restrict ::1
+restrict 198.51.100.123 serverresponse fuzz
+restrict fec0:: mask [ffff::] ignore
 interface drop ipv6
 interface ignore ipv4
 interface drop wildcard
 interface listen eth0
 interface listen ipv6
-interface listen 192.168.192.0/24
-interface listen 192.168.193.1
+interface listen 203.0.113.0/24
+interface listen 192.0.2.123
 phone "ATDT13034944774" "ATDT12027621594"
 setvar varnondef = "this variable does not have default after the value"
 setvar vanity = "name plate" default
 trap 127.0.0.1 interface 127.0.0.1 port 1234
-trap 127.0.0.2
+trap 192.0.2.2
 reset allpeers auth ctl io mem sys timer
